unit Defs;

interface

const FONT_FILE          = 'mario.fnt';
UNREGISTERED: Boolean    = FALSE;
MESSAGE: String          = 'Unregistered version';
const ERROR_1            = 'I/O error accessing data file';
const ERROR_2            = 'I/O error accessing level file';
const ERROR_3            = 'I/O error accessing font file';
const SKIP_PARAM         = '-S';
const TAB_PARAM          = '-T';
const DEMO_PARAM         = '-D';
const PASSWORD_1         = '-ZSJJWHD6';
const PASSWORD_2         = '-ABKBOBCJ3W';
const PASSWORD_3         = '-ITSTANTRUM';
const RED_COLOR          = 5;
const VERSION            = 3.5;
const LEVEL_WIDTH        = 2000;
const LEVEL_HEIGHT       = 1400;
const MAX_LEVELS         = 10;
const MARIO_SPEED        = 1;
const MARIO_MAX_SPEED    = 2;
const MARIO_JUMP_TIME    = 35;
const MARIO_UP_SPEED     = 2;
const MARIO_DOWN_SPEED   = 1;
const MARIO_FRAME_SPEED  = 10;
const MAX_LIVES          = 5;
const MONSTER_SPEED      = 1;
const MONSTER_DOWN_SPEED = 2;
const MONSTER_FRAME_TIME = 30;
const FISH_PAUSE_TIME    = 150;
const DEMO_TIME          = 500;
const MONSTER_FRAMES     = 62;
const PLATFORM_SPEED     = 10;
const MONEY_SPRITE       = 29;
const MARIO_SPRITE       = 53;
const TEXTURE_SPRITE     = 87;
const RENDER_COLOR       = 137;
const DATA_FILE          = 'mario.dat';
const LEVEL_FILE         = 'level';
const DATA_SIZE          = 28000;
const WIZARD_BEG         = 90;
const BEG_FIRE           = 83;
const COPYRIGHT          = 'Copyright (c) MATI 1998';

SOLID_TABLE: array[1..100] of Byte = (2,0,2,0,2,0,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
                                      1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
                                      1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
                                      0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);

SPEED_TABLE: array[1..6] of Byte = (20, 40, 5, 20, 30, 5);

FRAME_TABLE: array[1..6] of Byte = (0, 8, 10, 14, 15, 16);

INTRO_DATA: array[1..6, 1..10] of Byte = ((0 ,0 ,0 ,0 ,0 ,8 ,0 ,0 ,0 ,0 ),
                                          (0 ,8 ,0 ,0 ,10,9 ,11,8 ,0 ,0 ),
                                          (10,9 ,11,8 ,0 ,22,10,9 ,11,0 ),
                                          (0 ,22,10,9 ,11,22,0 ,23,0 ,0 ),
                                          (0 ,22,0 ,23,0 ,22,0 ,23,0 ,0 ),
                                          (12,13,13,13,13,13,13,13,13,14));

CONGRATULATIONS: array[1..16] of String[35]=

('  Congratulations! YOU won MARIO!',
 'This original game was written   ',
 'in Borland Pascal with objects   ',
 'v7.0.                            ',
 '  During writing this game there ',
 'were used following technologies:',
 '  - dynamic memory allocation    ',
 '  - dynamic object linking       ',
 '  - dynamic data linking         ',
 '  - using TASM 4.0               ',
 '  All graphical effects and      ',
 'functions was written in 100%    ',
 'assembler.                       ',
 '  Copyright (c) MATI, 1998.      ',
 '                                 ',
 '         *** THE END ***         ');

type
    TTerrain = record
      x, y, n: Integer;
    end;

    MonsterRec = record
      x, y, n: Integer;
    end;

    Platform = record
      x, y: Integer;
      Color: Byte;
      Dir: Byte;
      Range: Integer;
    end;
    
    Info = record
      NumTerrain: Integer;
      NumMonsters: Integer;
      NumPlats: Integer;
      NumTex: Integer;
    end;

implementation

end.